=== debian/changelog ===
piratecash (0.18.2.4-1) stable; urgency=medium

  * Fix headers for SPV clients

 -- Mistific@tor <0mistificator0@gmail.com>  Wed, 07 May 2025 16:16:29 +0000

piratecash (0.18.2.3-1) stable; urgency=medium

  * Add new dns seed dns.p.cash
  * Disconnect old nodes

 -- Mistific@tor <0mistificator0@gmail.com>  Sun, 28 Jul 2024 02:01:36 +0000

piratecash (0.18.2.2-1) stable; urgency=medium

  * fix: resolve some memory leaks
  * fix: Restore caching in CalcCbTxMerkleRootMNList
  * fix(rpc): masternode outputs should work correctly with multiple outputs created via a single tx
  * fix(coinjoin): fix version comparison check serialization bug
  * fix: speed up GetStateFor

 -- Mistific@tor <0mistificator0@gmail.com>  Sat, 13 Jul 2024 15:49:14 +0000

piratecash (0.18.2.0-1) stable; urgency=medium

  * ScanQuorums improvements
  * Added seeds nodes
  * Fix quorum relay members

 -- Mistific@tor <0mistificator0@gmail.com>  Sun, 07 Jul 2024 22:48:03 +0000

piratecash (0.18.1.0-1) stable; urgency=medium

  * Fix payment server
  * Remove old network support
  * Small part of pirate will be CORSARs
  * Gradual increase of rewards for masternodes from 0.1 to 60%.

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 29 Jan 2024 15:57:02 +0000

piratecash (0.18.0.1-1) stable; urgency=medium

  * We have released a major update PirateCash Core v18.

 -- Mistific@tor <0mistificator0@gmail.com>  Thu, 04 Jan 2024 09:40:16 +0000

piratecash (0.18.0.0-1) stable; urgency=medium

  * We have released a major update PirateCash Core v18.

 -- Mistific@tor <0mistificator0@gmail.com>  Sun, 24 Dec 2023 20:24:21 +0000

piratecash (0.11.7.0.60029-1) stable; urgency=medium

  * https://p.cash/hardfork/

 -- Mistific@tor <0mistificator0@gmail.com>  Sat, 16 Dec 2023 22:49:24 +0000

piratecash (0.11.6.4.60027-1) stable; urgency=medium

  * Update checkpoins and prepare for hardfork

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 03 Jul 2023 17:26:57 +0000

piratecash (0.11.6.2.60026-1) stable; urgency=medium

  * Disconnect from old peers
  * Reject wrong MN pay amounts

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 13 Jun 2022 07:29:34 +0000

piratecash (0.11.6.1.60026-1) stable; urgency=medium

  * Changed masternode reward percent from 917 000
  * Removed old SMS

 -- Mistific@tor <0mistificator0@gmail.com>  Fri, 03 Jun 2022 10:27:11 +0000

piratecash (0.11.5.13.60025-1) stable; urgency=medium

  * Disable TORv2 for masternodes (https://support.torproject.org/onionservices/v2-deprecation/)
  * [fix] masternode rank after enable spork 8
  * Disable masternode payments and connections to peers with protocol less 60024

 -- Mistific@tor <0mistificator0@gmail.com>  Tue, 14 Sep 2021 16:16:03 +0000

piratecash (0.11.5.12.60024-1) stable; urgency=medium

  * [fix] masternode connect (daemon crash)
  * [fix] masternode listen
  * [fix] check missing parameter masternodeaddr
  * [fix] masternode port checking
  * [fix] windows 10 issues
  * [add] support windows 32bit
  * [add] new checkpoint
  * [update] Bump openssl to 1.0.2u

 -- Mistific@tor <0mistificator0@gmail.com>  Fri, 27 Aug 2021 17:16:52 +0000

piratecash (0.11.5.11.60023-1) stable; urgency=medium

  * Logo rebranding
  * MN must use only port 18888
  * Reject multiple nodes on same address with different VINs
  * [fix] Duplicate Time in the rawtransaction rpc
  * Disable payments for MN with protocol less than 60022
  * Add depends scenarios for cross builds from linux

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 31 May 2021 07:55:31 +0000

piratecash (0.11.5.10.60022-3) stable; urgency=medium

  * [new] Up commits 7d37b6ad75f9988382568d9dda1f1fb20c5b0698

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 24 May 2021 20:32:24 +0000

piratecash (0.11.5.10.60022-2) stable; urgency=medium

  * [new] Up commits 3e8e95275231bec6fb17962c22e54241767945fb

 -- Mistific@tor <0mistificator0@gmail.com>  Wed, 19 May 2021 03:57:22 +0000

piratecash (0.11.5.10.60022-1) stable; urgency=medium

  * [new] Add vout to ListTransactions output
  * [fix] SMSG
  * [fix] net: fix a few races
  * [fix] Display correct amount for POS (listtransactions and listsinceblock)
  * [fix] ListTransactions for masternode rewards
  * [fix] testnet dir
  * [fix] --help command doesn’t work (Process help argument before datadir.)
  * [fix] Fix auto-deselection of peers

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 05 Apr 2021 20:02:34 +0000

piratecash (0.11.5.9.60022-1) stable; urgency=medium

  * [new] Add vout to ListTransactions output
  * [fix] net: fix a few races
  * [fix] Display correct amount for POS (listtransactions and listsinceblock)
  * [fix] ListTransactions for masternode rewards
  * [fix] testnet dir
  * [fix] --help command doesn’t work (Process help argument before datadir.)
  * [fix] Fix auto-deselection of peers

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 21 Sep 2020 13:57:55 +0000

piratecash (0.11.5.8.60022-1) stable; urgency=medium

  * Disable master node payments for 60020
  * Prevent duplicate connections where one is by name and another by ip
  * [fix] first start piratecashd when it run first time
  * [fix] getaddednodeinfo RPC call with dns=false
  * [fix] argument parsing oddity with -noX
  * [fix] Reserve only one network specific cached path per session
  * [fix] More fixes for blockchain corruption on OSX.
  * [fix] Testnet cashed dir

 -- Mistific@tor <0mistificator0@gmail.com>  Thu, 04 Jun 2020 09:22:39 +0000

piratecashd (0.11.5.7.60021) stable; urgency=medium

  * [fixed] hash sum piratecash
  * Properly handle errors during log message formatting
  * Do not call CloseSocketDisconnect from non-socket handler threads
  * fix possible memory leaks in CWallet::EncryptWallet
  * UI: wrong keypool default value displayed

 -- Mistific@tor <0mistificator0@gmail.com>  Mon, 13 Apr 2020 02:00:00 +0000

piratecashd (0.11.5.6.60020) stable; urgency=medium

  * [fixed] masternode information for persistant storage of the masternode payment cycle

