=== debian/control ===
Source: piratecash
Section: utils
Priority: optional
Maintainer: Mistific@tor
Uploaders: Mistific@tor
Build-Depends: debhelper,
 devscripts,
 automake,
 libtool,
 bash-completion,
 pkg-config,
 python3,
 git,
 dh-autoreconf,
 build-essential,
 libpiratecash-depends-dev
Standards-Version: 3.9.2
Homepage: https://piratecash.net/
Vcs-Git: git://github.com/piratecash/piratecash.git
Vcs-Browser: https://github.com/piratecash/piratecash

Package: piratecashd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: peer-to-peer network based digital currency - daemon
 PirateCash is an experimental new digital currency that enables instant, private
 payments to anyone, anywhere in the world. PirateCash uses peer-to-peer
 technology to operate with no central authority: managing transactions
 and issuing money are carried out collectively by the network. PirateCash Core
 is the name of the open source software which enables the use of this currency.
 .
 This package provides the daemon, piratecashd, and the CLI tool
 piratecash-cli to interact with the daemon.

Package: piratecash-qt
Architecture: any
Depends: ${misc:Depends}
Description: peer-to-peer network based digital currency - Qt GUI
 PirateCash is an experimental new digital currency that enables instant, private
 payments to anyone, anywhere in the world. PirateCash uses peer-to-peer
 technology to operate with no central authority: managing transactions
 and issuing money are carried out collectively by the network. PirateCash Core
 is the name of the open source software which enables the use of this currency.
 .
 This package provides piratecash-qt, a GUI for PirateCash based on Qt.

Package: piratecash-tx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: peer-to-peer digital currency - standalone transaction tool
 PirateCash is an experimental new digital currency that enables instant, private
 payments to anyone, anywhere in the world. PirateCash uses peer-to-peer
 technology to operate with no central authority: managing transactions
 and issuing money are carried out collectively by the network. PirateCash Core
 is the name of the open source software which enables the use of this currency.
 .
 This package provides piratecash-tx, a command-line transaction creation
 tool which can be used without a piratecash daemon.  Some means of
 exchanging minimal transaction data with peers is still required.
