=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

export DH_VERBOSE=1
export DH_OPTIONS=-v

DEB_HOST_GNU_TYPE_DIR   ?= $(shell ./depends/config.guess)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    BMAKEFLAGS += -j$(NUMJOBS)
endif

%:
	dh $@ --parallel --with autoreconf,bash-completion

override_dh_auto_clean:
	if [ -f Makefile ]; then $(MAKE) distclean; fi
	rm -rf Makefile.in aclocal.m4 configure src/Makefile.in src/piratecash-config.h.in src/build-aux src/qt/Makefile.in src/qt/test/Makefile.in src/test/Makefile.in

override_dh_auto_configure:
	./autogen.sh
	./configure LDFLAGS="-static-libstdc++ -static-libgcc"

override_dh_auto_build:
	$(MAKE) $(BMAKEFLAGS)

override_dh_auto_test:
